Attribute VB_Name = "PPglobal"
Declare Function LoadLibrary Lib "Kernel" (ByVal lpLibFileName As String) As Integer
Declare Sub FreeLibrary Lib "Kernel" (ByVal hLibModule As Integer)
Declare Function LoadBitmap Lib "User" (ByVal hInstance As Integer, ByVal lpBitmapName As Any) As Integer
Declare Function SelectObject Lib "GDI" (ByVal hDC As Integer, ByVal hObject As Integer) As Integer
Declare Function GetObjectGDI Lib "GDI" Alias "GetObject" (ByVal hObject As Integer, ByVal nCount As Integer, ByRef lpObject As Any) As Integer
Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer
Declare Function BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hcardDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long) As Integer
Declare Function CreateCompatibleDC Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function DeleteDC Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function SetBkColor Lib "GDI" (ByVal hDC As Integer, ByVal cColor As Long) As Long
Declare Function CreateBitmap Lib "GDI" (ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal cbPlanes As Integer, ByVal cbBits As Integer, lpvBits As Any) As Integer
Declare Function CreateCompatibleBitmap Lib "GDI" (ByVal hDC As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer) As Integer

Type BITMAP '14 bytes
  bmType As Integer
  bmWidth As Integer
  bmHeight As Integer
  bmWidthBytes As Integer
  bmPlanes As String * 1
  bmBitsPixel As String * 1
  bmBits As Long
End Type

Global hLibrary As Integer, rc%
Global hBitMap As Integer, hMaskMap As Integer
Global hMemDC As Integer
Global bm As BITMAP
Global iCardWidth As Integer, iCardHeight As Integer
Global iLoading As Integer
Global iOffset As Integer
Global iPos As Integer
Global nGCard As Integer, iGStake As Integer
Global nCardBack As Integer, nCardHigh As Integer


' Scoring controls
Global lScore As Long
Global iTurnCards As Integer
Global iConsBonus As Integer
Global iMoveBonus As Integer
Global iRoundMult As Integer
Global iRoundScore As Integer
Global lHighScore As Long
Global iGamesPlayed As Integer
Global lTotalScore As Long
Global iRound As Integer
Global iConsMoves As Integer
Sub TransparentBlt(ByVal srcCard As Long, ByVal destDC As Integer, ByVal destX As Integer, ByVal destY As Integer)
  Dim cardDC As Integer ' source bitmap (color)
  Dim saveDC As Integer ' copy of board destination
  Dim maskDC As Integer ' mask bitmap (monochrome)
  
  Dim hCardBmp As Integer ' Source cardimage
  Dim hSaveBmp As Integer ' Bitmap stores copy of board
  Dim hMaskBmp As Integer ' Bitmap stores mask (monochrome)
  
  Dim hCardPrevBmp As Integer ' Holds previous bitmap in card image DC
  Dim hSavePrevBmp As Integer ' Holds previous bitmap in board copy DC
  Dim hMaskPrevBmp As Integer ' Holds previous bitmap in the mask DC
  
  Dim Success As Integer 'Stores result of call to Windows API
  
  ' Make compatible DCs (should really check return!)
  cardDC = CreateCompatibleDC(destDC)
  saveDC = CreateCompatibleDC(destDC)
  maskDC = CreateCompatibleDC(destDC)
         
  ' Get DLL foreground image and mask
  hCardBmp = LoadBitmap(hLibrary, srcCard)
  If hCardBmp = 0 Then
    MsgBox "Couldn't load image" + Str$(srcCard), vbCritical + vbOKOnly, "TransparentBlt"
    Unload fGulf
  End If
  l& = 102
  hMaskBmp = LoadBitmap(hLibrary, l&)
  If hMaskBmp = 0 Then
    MsgBox "Couldn't load image 102", vbCritical + vbOKOnly, "TransparentBlt"
    Unload fGulf
  End If
  
  'Create color bitmaps for final result & stored copy of source
  hSaveBmp = CreateCompatibleBitmap(destDC, iCardWidth, iCardHeight)
  hCardPrevBmp = SelectObject(cardDC, hCardBmp) 'Select bitmap in DC (card)
  hSavePrevBmp = SelectObject(saveDC, hSaveBmp) 'Select bitmap in DC (board)
  hMaskPrevBmp = SelectObject(maskDC, hMaskBmp) 'Select bitmap in DC (mask)
  
  ' Actually perform the blitting
  Success = BitBlt(saveDC, 0, 0, iCardWidth, iCardHeight, destDC, destX, destY, vbSrcCopy) 'Make backup of source bitmap to restore later
  Success = BitBlt(saveDC, 0, 0, iCardWidth, iCardHeight, maskDC, 0, 0, vbSrcAnd)
  Success = BitBlt(saveDC, 0, 0, iCardWidth, iCardHeight, cardDC, 0, 0, vbSrcPaint)
  Success = BitBlt(destDC, destX, destY, iCardWidth, iCardHeight, saveDC, 0, 0, vbSrcCopy)
  
  ' Deselect the GDI objects
  hPrevBmp = SelectObject(cardDC, hCardPrevBmp) 'Select orig object
  hPrevBmp = SelectObject(saveDC, hSavePrevBmp) 'Select orig object
  hPrevBmp = SelectObject(maskDC, hMaskPrevBmp) 'Select orig object
         
  ' Kill objects and DCs
  Success = DeleteObject(hCardBmp)     'Deallocate system resources.
  Success = DeleteObject(hSaveBmp)   'Deallocate system resources.
  Success = DeleteObject(hMaskBmp)   'Deallocate system resources.
  
  Success = DeleteDC(cardDC)          'Deallocate system resources.
  Success = DeleteDC(saveDC)         'Deallocate system resources.
  Success = DeleteDC(maskDC)         'Deallocate system resources.
End Sub

